#!/usr/bin/env python
# -*- coding: utf-8 -*-
"""
Created on Tue Sep  1 16:30:10 2015

@author: mcanulty
"""

import mido
import mido.backends.portmidi
import sys
import signal
import time
import random




#***************************************************************
#********************** EXIT handler ***************************
#***************************************************************
RUNNING = True

def signal_handler(signal, frame):
    global RUNNING
    
    RUNNING = False
    print('\nSIGINT\n')
    
#   sys.stdout.flush()  
#   sys.exit(0)
        
        
signal.signal(signal.SIGINT, signal_handler)



#***************************************************************
#***************************************************************
#***************************************************************

midiPortName = 'K-Mix Audio Control'
#midiPortName = 'USB MIDI Device Port 1'

def runMidi():
    inputs = mido.get_input_names()
    
    print "\n\n\n" , "Checking midi ports..."
    print "Available inputs are:", inputs
    
    if midiPortName in inputs:
        print "\n", "K-Mix available, opening port..."
        sys.stdout.flush()              # Have to flush stdout here, or else
                                        # the output gets held up until later
                                        
        print "\n", "using random period:", period, "+-", random_range

        midiSend()
        
        sys.stdout.flush()
        sys.exit(0)
        
    else:
        print "\n", "No " + midiPortName


#***************************************************************
#***************************************************************
#***************************************************************

period = .001;
random_range = period/3;


def midiSend():
    global RUNNING
    
    location = 0    
    
    with mido.open_output(midiPortName) as outport:
        
        #sysex starts midi response to setting changes from board
        syxOut = mido.Message('sysex', data=[0x00, 0x01, 0x5F, 0x23, 0x00, 0x00, 0x00,  0x00, 0x00, 0x00, 0x00])
        outport.send(syxOut) 
        time.sleep(0.5)
        
        while(RUNNING):
            location = (location + 1) % 100
            outMsg = mido.Message('control_change', channel=0, control=1, value=location)

            for chan in range(4):
                outMsg.channel = chan
                outport.send(outMsg)
             
            time.sleep(period + random.random()*random_range - random_range/2);
        outport.close()
        
            

#***************************************************************
#***************************************************************
#***************************************************************


#***************************************************************
#***************************************************************
#***************************************************************



runMidi()
        

